[Plugin] Select by Z
-
Does a plugin exist that will allow you select all edges and faces have have the same Z coordinate in world space? It would select all coplanar object based on a given height in world space.....edges or faces.
Update - Select by Z .rb files. - Thanks TIG & BTM
Select Faces by Z - Choose a face and run select faces by Z to select every other face on the same XY plane.
Select Edges by Z - Select an edge and run script to select all other edges that have been drawn on the same XY plane. Would be a good script for CAD cleanup and identifying edges that are non coplanar.
-
I don't know of one, but it's quite easily done...
Do you want a starting dialog to specify the Z value in [current units] ?
Do you want to select all co-planar faces OR all co-normal [angle of slope] faces ? Do you want to treat any 'reversed' faces as being co-planar/co-normal ?
Do you want to select all co-planar edges ?
Do you want to select all faces with any part of themselves at a given Z height ?
Do you want to select all faces with their lowest bounds at a given Z height ?
Do you want to select all faces with their highest bounds at a given Z height ?
Do you want to select all edges with any part of themselves at a given Z height ?
Do you want to select all edges with a start at a given Z height ?
Do you want to select all edges with an end at a given Z height ?
Do you want to select all of the selected faces' edges or include 'unfaced' edges too ?
etcWe could probably quickly hack something together, once it's clarified...
-
Thanks TIG! I guess there are a lot more variables than I considered.
In thinking about how it would work, a couple scenarios come to mind.
-
Click on a face or edge, then right click and choose "select similar by Z". The script would search and find all similar faces or edges that register at the same coordinate on the Z.
-
Another more interesting option, would be having the ability to draw out a selection rectangle that is locked on a plane. Similar to a section cut plane, or grid of some kind, that would be used to select everything coplanar that falls completely within that plane or grid. If you could then move or rotate that selection plane, you could align it on any Z height or angle and use it to select all that intersects it. Don't know if it's possible, but that would be an amazing tool.
As far as your questions-
Do you want a starting dialog to specify the Z value in [current units] ? I think it would make more sense to select an existing entity and match the rest of the selection to that, or else you would have to spend time figuring out the height from zero, which may require a few steps and slow down the process.
Do you want to select all co-planar faces OR all co-normal [angle of slope] faces ? Do you want to treat any 'reversed' faces as being co-planar/co-normal ? Just co-planar would work for me, but I'm sure co-normal would be useful in some situations to some people. Yes, I would say reversed faces should be treated as co-planar.
Do you want to select all co-planar edges ? YES
Do you want to select all faces with any part of themselves at a given Z height ? NO
Do you want to select all faces with their lowest bounds at a given Z height ? No, but perhaps optionally. Might be useful for selecting everything above a certain height.
Do you want to select all faces with their highest bounds at a given Z height ? No, but perhaps optionally. Might be useful for selecting everything below a certain height.
Do you want to select all edges with any part of themselves at a given Z height ? No, can't think of a situation this would be useful for.
Do you want to select all edges with a start at a given Z height ? Yes, this would be useful
Do you want to select all edges with an end at a given Z height ? Yes to this also
Do you want to select all of the selected faces' edges or include 'unfaced' edges too ? Yes, unfaced edges too. -
-
I'll try at look at it some time next week...
-
Thanks TIG!!!! I'm working on a tutorial for some new users on another forum that are continually having problems with getting certain faces to close. I thought this script would be particularly useful to select all the edges and faces on a certain plane, moving a copy of them to an open space, then running the stray lines plugin to identify any non co-planar lines.
-
Just wondering if this were possibly still in the works? TIG?
I had a few times this week that I needed to select all the faces at a given height and this script would've been very useful. No hurry, just wondering. Thanks!
-
@earthmover said:
I had a few times this week that I needed to select all the faces at a given height ...
Have you visited the Ruby Console? You could get this done there without waiting on a Ruby.
-
@earthmover said:
Just wondering if this were possibly still in the works? TIG?
I had a few times this week that I needed to select all the faces at a given height and this script would've been very useful. No hurry, just wondering. Thanks!
Time flies when you are enjoying yourself...
These are the lines of code you need...
def selectfacesbyz() model=Sketchup.active_model ss=model.selection; face=ss[0]; ss.clear model.active_entities.each{|e|ss.add(e)if e.class==Sketchup;;Face and e.bounds.min.z==face.bounds.min.z} end#if
[Untested !]
Paste all of it into a selectfacesbyz.rb file, restart SUp and see what happens...
Usage:
Select a face... then in Ruby Console type/paste:selectfacesbyz
it selects every face at same height.
You can make the menu by copying similar code ?
-
Thanks TIG! It indeed works. I tried this for adding to the menu as an option, but it didn't work. What am I missing?
def selectfacesbyz() model=Sketchup.active_model ss=model.selection; face=ss[0]; ss.clear model.active_entities.each{|e|ss.add(e)if e.class==Sketchup;;Face and e.bounds.min.z==face.bounds.min.z} ### Menu ### UI.menu("Plugins").add_item("Select Faces by Z"){selectfacesbyz} end#if
-
Put the menu OUTSIDE of the def...end thus:
def selectfacesbyz() model=Sketchup.active_model ss=model.selection; face=ss[0]; ss.clear model.active_entities.each{|e|ss.add(e)if e.class==Sketchup;;Face and e.bounds.min.z==face.bounds.min.z} end#def UI.menu("Plugins").add_item("Select Faces by Z"){selectfacesbyz} if not file_loaded?(File.basename(__FILE__)) file_loaded(File.basename(__FILE__))
The file_loded bit ensures it only loads into menu if you reload the Ruby manually later...
You're now a scripter !
Next: test if ss[0], test if ss[0] is a Face etc and if not UI.messagebox()... "Must Select a Face First.."
-
@tig said:
Next: test if ss[0], test if ss[0] is a Face etc and if not UI.messagebox()... "Must Select a Face First.."
Would this work?
def selectfacesbyz mo=Sketchup.active_model() ss = mo.selection() if ss.empty? UI.messagebox("Must Select a Face First") else mo.start_operation "selectfacesbyz"
-
Yes, that's OK.
But I'd just use this:###... if ss.empty? or not ss[0].class==Sketchup;;Face UI.messagebox("Must Select a Face First...") return nil end ### then rest of code assuming it does get past this test...
'return nil' simply stops the process...
Note how I also added a test to see if the first thing in the selection is not a Face...
You will winkle a script out of me bit by bit... -
So kind my friend. Thanks for making me work for it! I'm looking through code to try and determine how to also have the selection apply to edges, but the variables for edges are greater. If I could figure out how to apply it to just work with edges that exist solely on an xy plane....
-
edge.start.position.z==edge.end.position.z
is 'flat'
you could also get the lower value withedge.bounds.min.z
?
-
ss=model.selection; face=ss[0]; ss.clear
So I assume this lines tells sketchup if the selection is a face then process this line
model.active_entities.each{|e|ss.add(e)if e.class==Sketchup::Face and e.bounds.min.z==face.bounds.min.z}
And this says to add to the selection all other faces with the with z bounds.
To translate this to apply for edges, is it as simple as changing the name face to edges and defining it further with the xy constraint code you provided? I tried it a few different ways and I keep getting errors.
-
Correct - test that the entities are Edges...
e.class==Sketchup;;Edge
Then test to see if same height as
edge=ss[0]
###you need to have got edge'smin.z
...
There are several ways of testing for entity types - the [probable] fastest ise.class==Sketchup::Edge
but there are also
e.is_a?("Edge") e.kind_of?("Edge") e.typename=="Edge"
etc...
Now you can also try code to manipulate a selection so that say only edges or faces are left in it...
For example:ss.each{|e|ss.remove(e) if not e.class==Sketchup;;Face}### leaves only faces ### OR ss.each{|e|ss.remove(e) if not e.class==Sketchup;;Edge}### leaves only edges
-
def selectedgesbyz() model=Sketchup.active_model ss=model.selection; Edge=ss[0]; ss.clear model.active_entities.each{|e|ss.add(e)if e.class==Sketchup;;Edge and e.bounds.min.z==edge.start.position.z==edge.end.position.z} end#if UI.menu("Plugins").add_item("Select Edges by Z"){selectedgesbyz} if not file_loaded?(File.basename(__FILE__)) file_loaded(File.basename(__FILE__))
Got this so far. Something is wrong in the syntax. Can you show me the error to my ways. I have no idea how the language works, but it's been a good mental exercise and I'd love to learn more. Thanks for your help.
-
@earthmover said:
def selectedgesbyz() > model=Sketchup.active_model > ss=model.selection; Edge=ss[0]; ss.clear > model.active_entities.each{|e|ss.add(e)if e.class==Sketchup;;Edge and e.bounds.min.z==edge.start.position.z==edge.end.position.z} > end#if > UI.menu("Plugins").add_item("Select Edges by Z"){selectedgesbyz} if not file_loaded?(File.basename(__FILE__)) > file_loaded(File.basename(__FILE__))
Got this so far. Something is wrong in the syntax. Can you show me the error to my ways. I have no idea how the language works, but it's been a good mental exercise and I'd love to learn more. Thanks for your help.
Well, first problem is that you capitalized edge in edge=ss[0]. Second, you can't have something like 'if a==b==c'. You have to seperate it into 'if a==b and a==c'. Here's a working example.
def selectedgesbyz() model=Sketchup.active_model ss=model.selection; edge=ss[0]; ss.clear model.active_entities.each{|e|ss.add(e)if e.class==Sketchup;;Edge and (e.bounds.min.z)==(edge.start.position.z) and (e.bounds.min.z)==(edge.end.position.z)} end#if UI.menu("Plugins").add_item("Select Edges by Z"){selectedgesbyz} if not file_loaded?(File.basename(__FILE__)) file_loaded(File.basename(__FILE__))
-
Thanks - BTM ... all variables must start with a lower-case letter and test 'x==y and z==a' are both the correct way forward... We'' make a scripter out of EarthMover yet
-
Thanks BTM - that makes sense and I follow the logic behind the code. Perhaps I will try and find time to learn the language. I am good at obsessing and not so good at multi-tasking, so it may have to wait till the snow is falling and my work slows down.
Regarding the script, it indeed is working. However, it is not properly defining the edges end bounds. The script is selecting any edge which has one of the their bounds (verticies) corresponding with the selection, so it is thus selecting also vertical lines and diagonal lines who's start bounds is on the Z in relevance to the selection. Any suggestions for further defining the end bounds so that the script will only select lines only completely on the same XY plane as the selection?
Advertisement